function [weights regulazor optMSE] = adaptiveTrainRLS_Regress_CG( X, Y, nFold, prior, ProjMtx )

n = size(X,1);

if nargin < 4
    prior = zeros(size(X,2)+1,1);
elseif size(prior,1) == size(X,2)
    prior = [0; prior];
    %size(prior)
end

if nargin < 5
    %ProjMtx = eye(size(X,2)+1);
elseif size(ProjMtx,1) == size(X,2)
    temp = ProjMtx;
    ProjMtx = zeros(size(X,2)+1, size(X,2)+1);
    ProjMtx(1,1) = 1;
    ProjMtx(2:(size(X,2)+1), 2:(size(X,2)+1)) = temp;
    clear temp;
    %size(ProjMtx)
end

%index postive examples and negative examples
index = randperm(n);

for i = 1 : nFold
    trainFold{i} = index( [1 : round((i-1)*n/nFold), round((i)*n/nFold)+1 : n] );
    testFold{i} = index( round((i-1)*n/nFold)+1 : round((i)*n/nFold) );
    %disp(sprintf('size of Train fold %g: (%g, %g)', i, size(trainFold{i},1), size(trainFold{i},2)));
    %disp(sprintf('size of Test fold %g: (%g, %g)', i, size(testFold{i},1), size(testFold{i},2)));
end


%find the best lamda
%lamda = [0.00001, 0.00004, 0.0001, 0.0004, 0.0007, 0.001, 0.004, 0.007, 0.01, 0.04, 0.07, 0.1, 0.4, 0.7, 1.0, 4, 7, 10, 40, 70, 100, 400, 700, 1000, 4000, 7000, 10000, 40000, 100000];
%disp('few lambda');
%lamda = 0.00001*[0.001, 0.004, 0.01, 0.04, 0.1, 0.4, 1.0, 4, 10, 40, 100, 400, 1000, 4000, 10000, 40000, 100000, 400000, 1000000];
%lamda = 10.^[-3 -2.5 -2 -1.5 -1 -0.5  0 0.5 1 1.5 2 2.5 3 3.5 4 4.5 5 5.5 6 6.5 7 8];
%lamda = 10.^[-3 -2.5 -2 -1.5 -1 -0.5  0 0.5 1 1.5 2 2.5 3 3.5 4 4.5 5];
%lamda = 10.^[-3:0.25:6];
lamda = 10 .^ [-6:8];


for i = 1 : size(lamda,2)
    error(i) = 0;
    for j = 1 : nFold

        if nargin > 4
            weights = TrainRLS_Regress_CG([ones(size(X(trainFold{j},:),1),1), X(trainFold{j},:)], Y(trainFold{j},:), lamda(i), prior, ProjMtx );
        else
            weights = TrainRLS_Regress_CG([ones(size(X(trainFold{j},:),1),1), X(trainFold{j},:)], Y(trainFold{j},:), lamda(i), prior);
        end
        
        testError = mean( ( [ones(size(X(testFold{j},:),1),1), X(testFold{j},:)]*weights - Y(testFold{j},:) ).^2 );
        error(i) = error(i) + testError;
        
        %disp(sprintf('This fold has error: %g', tempE));
    end
    error(i) = error(i)/nFold;
    disp(sprintf('Finally, error for lamda %g is averaged as %g', lamda(i), error(i)));
end



C = min(error);
C2 = min(error(length(error):-1:1));
Is = find(error==C);
I = Is(round(length(Is)/2));
if C~=C2
    C
    C2
    error('C cannot be different to C2');
end
fprintf(1,'Regression, minimum error %g at lamda:', C);
disp(Is);
fprintf(1,'Choose: %d\n', I);
optMSE = C;

regulazor = lamda(I);
if nargin > 4
    weights = TrainRLS_Regress_CG([ones(size(X,1),1), X], Y, regulazor, prior, ProjMtx );
else
    weights = TrainRLS_Regress_CG([ones(size(X,1),1), X], Y, regulazor, prior);
end